// MFCIteratorDemo.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MFCIteratorDemo.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MFCIteratorDemoDoc.h"
#include "MFCIteratorDemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFCIteratorDemoApp

BEGIN_MESSAGE_MAP(CMFCIteratorDemoApp, CWinApp)
    //{{AFX_MSG_MAP(CMFCIteratorDemoApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
        // NOTE - the ClassWizard will add and remove mapping macros here.
        //    DO NOT EDIT what you see in these blocks of generated code!
    //}}AFX_MSG_MAP
    // Standard file based document commands
    ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
    // Standard print setup command
    ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCIteratorDemoApp construction

CMFCIteratorDemoApp::CMFCIteratorDemoApp()
{
    // TODO: add construction code here,
    // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMFCIteratorDemoApp object

CMFCIteratorDemoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMFCIteratorDemoApp initialization

BOOL CMFCIteratorDemoApp::InitInstance()
{
    AfxEnableControlContainer();

    // Standard initialization
    // If you are not using these features and wish to reduce the size
    //  of your final executable, you should remove from the following
    //  the specific initialization routines you do not need.

#ifdef _AFXDLL
    Enable3dControls();         // Call this when using MFC in a shared DLL
#else
    Enable3dControlsStatic();   // Call this when linking to MFC statically
#endif

    // Change the registry key under which our settings are stored.
    // TODO: You should modify this string to be something appropriate
    // such as the name of your company or organization.
    SetRegistryKey(_T("Local AppWizard-Generated Applications"));

    LoadStdProfileSettings();  // Load standard INI file options (including MRU)

    // Register the application's document templates.  Document templates
    //  serve as the connection between documents, frame windows and views.

    CMultiDocTemplate* pDocTemplate;
    pDocTemplate = new CMultiDocTemplate(
        IDR_DOC_A,
        RUNTIME_CLASS(CMFCIteratorDemoDoc),
        RUNTIME_CLASS(CChildFrame), // custom MDI child frame
        RUNTIME_CLASS(CMFCIteratorDemoView));
    AddDocTemplate(pDocTemplate);

    pDocTemplate = new CMultiDocTemplate(
        IDR_DOC_B,
        RUNTIME_CLASS(CMFCIteratorDemoDoc),
        RUNTIME_CLASS(CChildFrame), // custom MDI child frame
        RUNTIME_CLASS(CMFCIteratorDemoView));
    AddDocTemplate(pDocTemplate);

    pDocTemplate = new CMultiDocTemplate(
        IDR_DOC_C,
        RUNTIME_CLASS(CMFCIteratorDemoDoc),
        RUNTIME_CLASS(CChildFrame), // custom MDI child frame
        RUNTIME_CLASS(CMFCIteratorDemoView));
    AddDocTemplate(pDocTemplate);

    // create main MDI Frame window
    CMainFrame* pMainFrame = new CMainFrame;
    if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
        return FALSE;
    m_pMainWnd = pMainFrame;

    // Parse command line for standard shell commands, DDE, file open
    CCommandLineInfo cmdInfo;
    ParseCommandLine(cmdInfo);

    // Dispatch commands specified on the command line
    if (!ProcessShellCommand(cmdInfo))
        return FALSE;

    // The main window has been initialized, so show and update it.
    pMainFrame->ShowWindow(m_nCmdShow);
    pMainFrame->UpdateWindow();

    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    CString m_AboutText;
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
        // No message handlers
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    m_AboutText = _T(
        "This demo of the MFC Iterator classes shows how they may be used to "
        "iterate through MFC containers, and apply an operation to the contents "
        "of nested MFC container classes.\r\n\r\n"
        "In this demo, the container classes are:\r\n\r\n"
        "1. The application (CWinApp) which contains document templates (CDocTemplate).\r\n"
        "2. The document templates, which contain documents (CDocument).\r\n"
        "3. The documents, which contain views (CView).\r\n\r\n"
        "The application has 3 document templates, each with a document (Doc A, Doc B, Doc C), "
        "that each have a default view.\r\n\r\n"
        "Using the MFC Iterator classes, all the views in all the documents in all the "
        "document templates in the application can be iterated, and the operation that will "
        "be applied to each in this demo is \"Toggle Minimise Window\".\r\n\r\n"
        "The effect of this will be to toggle the state of every window in the application "
        "between the minimised and the restored state.\r\n\r\n"
        "To test this facility, create some windows in the usual way, and use the menu "
        "option: 'Window\\DEMO: Toggle Minimise All', "
        "or the toolbar button on the far right of the toolbar.\r\n\r\n"
        "You will find all the relevant code in MainFrm.cpp and the headers it includes.\r\n\r\n"
        "I hope you find this demo a useful intoduction to STL iterators,\r\n\r\n"
        "\tDave Lorde");
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    DDX_Text(pDX, IDC_ABOUT_TEXT, m_AboutText);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMFCIteratorDemoApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMFCIteratorDemoApp message handlers

