#ifndef MFCITERATORS_H
#define MFCITERATORS_H
//***************************************************************************
//
// ViewIter, DocIter, and DocTemplateIter class implementations.
//
// Iterator classes for iterating views, documents, and doctemplates.
//
//***************************************************************************

#if _MSC_VER > 1000
#pragma once
#endif   // _MSC_VER > 1000

#include "BaseMFCIter.h"

class ViewIter : public BaseMFCIter< CView*, CDocument >
{
public:
   ViewIter(CDocument* pDoc = 0) : BaseMFCIter< CView*, CDocument >
      (pDoc, CDocument::GetFirstViewPosition, CDocument::GetNextView)   
      {}
};

class DocIter : public BaseMFCIter< CDocument*, CDocTemplate >
{
public:
   DocIter(CDocTemplate* pDT = 0) : BaseMFCIter< CDocument*, CDocTemplate >
      (pDT, CDocTemplate::GetFirstDocPosition, CDocTemplate::GetNextDoc)   
      {}
};

class CDocTemplateIter : public BaseMFCIter< CDocTemplate*, CWinApp >
{
public:
   CDocTemplateIter(CWinApp* pApp = 0) : BaseMFCIter< CDocTemplate*, CWinApp >
      (pApp, CWinApp::GetFirstDocTemplatePosition, CWinApp::GetNextDocTemplate)
   {}
};

#endif